local S,C,L = unpack(SanUI)

-- Minimap
TukuiMinimap:ClearAllPoints()
TukuiMinimap:SetPoint("TOPLEFT",UIParent,"TOPLEFT",5,-5)

-- Bars: Bar 1 will contain all main Buttons, Bar 2 is just moved on top of it, background made invisible,
--       3 and 4 must go, Bar 5 stays at the rigt, 6 & 7 anchor to it
TukuiBar1:ClearAllPoints()
TukuiBar1:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, 5)
TukuiBar1:SetWidth((S.buttonsize * 24) + (S.buttonspacing * 25))

-- Rearrange buttons of bar 2
for i=1, 12 do
    local b = _G["MultiBarBottomLeftButton"..i]
    local b2 = _G["MultiBarBottomLeftButton"..i-1]
    b:SetSize(S.buttonsize, S.buttonsize)
    b:ClearAllPoints()
    b:SetFrameStrata("BACKGROUND")
    b:SetFrameLevel(15)
    b:ClearAllPoints()
    
    if i == 1 then
        b:SetPoint("LEFT", TukuiBar1, "LEFT",(S.buttonsize*12)+(S.buttonspacing*13), 0)
    else
        b:SetPoint("LEFT", b2, "RIGHT", S.buttonspacing, 0)
    end
end
RegisterStateDriver(TukuiBar1, "visibility", "[petbattle] hide; show")

TukuiBar2:ClearAllPoints()
TukuiBar2:SetAllPoints(TukuiBar1)

TukuiBar3:ClearAllPoints()
TukuiBar3:Point("BOTTOM", TukuiBar1, "TOP", 0, 2+S.buttonsize+S.buttonspacing)
TukuiBar3:SetWidth((S.buttonsize * 24) + (S.buttonspacing * 25))
TukuiBar3:SetHeight(S.buttonsize + 2*S.buttonspacing)
TukuiBar3:Show()
TukuiBar3:SetAlpha(1)
      
TukuiBar4:ClearAllPoints()
TukuiBar4:SetAllPoints(TukuiBar3)
TukuiBar4:Show()
TukuiBar4:SetAlpha(1)

local function mOverBars(alpha)
    TukuiBar3:SetAlpha(alpha)
    TukuiBar4:SetAlpha(alpha)
end

 -- Rearrange buttons of bar 3
for i=1, 12 do
    local b = _G["MultiBarBottomRightButton"..i]
    local b2 = _G["MultiBarBottomRightButton"..i-1]
    b:SetSize(S.buttonsize, S.buttonsize)
    b:ClearAllPoints()
    b:SetFrameStrata("BACKGROUND")
    b:SetFrameLevel(15)
    b:ClearAllPoints()
   
    if i == 1 then
            b:SetPoint("LEFT", TukuiBar3, "LEFT",4, 0)
    else
            b:SetPoint("LEFT", b2, "RIGHT", S.buttonspacing, 0)
    end

    b:SetScript("OnEnter", function(self) mOverBars(1) end)
    b:SetScript("OnLeave", function(self) mOverBars(0) end)
end

 -- Rearrange buttons of bar 4
for i=1, 12 do
    local b = _G["MultiBarLeftButton"..i]
    local b2 = _G["MultiBarLeftButton"..i-1]
    b:SetSize(S.buttonsize, S.buttonsize)
    b:ClearAllPoints()
    b:SetFrameStrata("BACKGROUND")
    b:SetFrameLevel(15)
    b:ClearAllPoints()
   
    if i == 1 then
            b:SetPoint("LEFT", TukuiBar4, "LEFT",(S.buttonsize*12)+(S.buttonspacing*13), 0)
    else
            b:SetPoint("LEFT", b2, "RIGHT", S.buttonspacing, 0)
    end

    b:SetScript("OnEnter", function(self) mOverBars(1) end)
    b:SetScript("OnLeave", function(self) mOverBars(0) end)
end

mOverBars(0)

TukuiBar5:SetPoint("RIGHT", UIParent, "RIGHT", -5, -14)

-- Invisible Action Bar Background, used for positioning
InvTukuiActionBarBackground:SetPoint("TOPLEFT", TukuiBar1)
InvTukuiActionBarBackground:SetPoint("BOTTOMRIGHT", TukuiBar1)

-- Reposition everything on the bottom of the UI from Tukui
TukuiInfoLeftLineVertical:Point("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 9, 22)
TukuiInfoRightLineVertical:Point("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -9, 22)

-- The buttons that show & hide some of the bars are not needed anymore
TukuiBar4Button:Kill()
TukuiBar3Button:Kill()
TukuiBar2Button:Kill()

TukuiLineToABRight:SetParent(TukuiPetBattleHider)
TukuiLineToABRight:SetFrameStrata("BACKGROUND")
TukuiLineToABRight:SetFrameLevel(1)
TukuiLineToABLeft:SetParent(TukuiPetBattleHider)
TukuiLineToABLeft:SetFrameStrata("BACKGROUND")
TukuiLineToABLeft:SetFrameLevel(1)

--ChatFrame 4 is where skada resides, so we move it to the left
local ChangeDefaultChatPosition = function(frame)

    if frame then

        local id = frame:GetID()
        local name = FCF_GetChatWindowInfo(id)

        if id == 4 and name == LOOT then
            if not frame.isDocked then
                if frame.isLocked then FCF_SetLocked(frame, 0) else print("NOT LOCKED") end
                frame:ClearAllPoints()
                frame:Point("BOTTOMLEFT", TukuiInfoLeft, "TOPLEFT", 0, 6)
                frame:SetJustifyH("LEFT")
                FCF_DockFrame(ChatFrame4) 
            end
        end
    end
end
hooksecurefunc("FCF_RestorePositionAndDimensions", ChangeDefaultChatPosition)

-- put a 'c' on cubeleft, since clicking on it opens the chat menu
local cubeleft = _G["TukuiCubeLeft"]
        
if cubeleft then
    local Text = cubeleft:CreateFontString(nil, "OVERLAY")
    Text:SetFont(C.media.font, 10)
    Text:SetText("c")
    Text:SetJustifyH("CENTER")
    Text:SetJustifyV("MIDDLE")
    Text:Point("CENTER",cubeleft)
    Text:Show()
    
    cubeleft.text = Text
end